com.fasterxml.jackson.databind.deser.std

## Class StdDelegatingDeserializer<T>

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonDeserializer<T>
  - - com.fasterxml.jackson.databind.deser.std.StdDeserializer<T>
    - - com.fasterxml.jackson.databind.deser.std.StdDelegatingDeserializer<T>

Type Parameters:
  `T` - Target type to convert to, from delegate type

All Implemented Interfaces:
  ContextualDeserializer, ResolvableDeserializer, Serializable

    public class StdDelegatingDeserializer<T>
    extends StdDeserializer<T>
    implements ContextualDeserializer, ResolvableDeserializer

Deserializer implementation where given Java type is first deserialized by a standard Jackson deserializer into a delegate type; and then this delegate type is converted using a configured `Converter` into desired target type. Common delegate types to use are `Map` and `JsonNode`.

Note that although types (delegate, target) may be related, they must not be same; trying to do this will result in an exception.

Since 2.5 There is `StdNodeBasedDeserializer` that is a simplified version for cases where intermediate type is `JsonNode`

Since:
  2.1
See Also:
  `StdNodeBasedDeserializer`, `Converter`, Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer

`JsonDeserializer.None`

### Field Summary

Fields
`protected Converter<Object,T>` `_converter`
`protected JsonDeserializer<Object>` `_delegateDeserializer` Underlying serializer for type `T`.
`protected JavaType` `_delegateType` Fully resolved delegate type, with generic information if any available.

### Fields inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

`_valueClass, F_MASK_INT_COERCIONS`

### Constructor Summary

Constructors
`` `StdDelegatingDeserializer(Converter<?,T> converter)`
`` `StdDelegatingDeserializer(Converter<Object,T> converter, JavaType delegateType, JsonDeserializer<?> delegateDeserializer)`
`protected` `StdDelegatingDeserializer(StdDelegatingDeserializer<T> src)`

### Method Summary

Methods
`protected Object` `_handleIncompatibleUpdateValue(JsonParser p, DeserializationContext ctxt, Object intoValue)` Overridable handler method called when `deserialize(JsonParser, DeserializationContext, Object)` has been called with a value that is not compatible with delegate value.
`protected T` `convertValue(Object delegateValue)` Method called to convert from "delegate value" (which was deserialized from JSON using standard Jackson deserializer for delegate type) into desired target type.
`JsonDeserializer<?>` `createContextual(DeserializationContext ctxt, BeanProperty property)` Method called to see if a different (or differently configured) deserializer is needed to deserialize values of specified property.
`T` `deserialize(JsonParser p, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
`T` `deserialize(JsonParser p, DeserializationContext ctxt, Object intoValue)` Alternate deserialization method (compared to the most commonly used, `JsonDeserializer.deserialize(JsonParser, DeserializationContext)`), which takes in initialized value instance, to be configured and/or populated by deserializer.
`Object` `deserializeWithType(JsonParser p, DeserializationContext ctxt, TypeDeserializer typeDeserializer)` Base implementation that does not assume specific type inclusion mechanism.
`JsonDeserializer<?>` `getDelegatee()` Accessor that can be used to determine if this deserializer uses another deserializer for actual deserialization, by delegating calls.
`Class<?>` `handledType()` Method for accessing type of values this deserializer produces.
`void` `resolve(DeserializationContext ctxt)` Method called after deserializer instance has been constructed (and registered as necessary by provider objects), but before it has returned it to the caller.
`protected StdDelegatingDeserializer<T>` `withDelegate(Converter<Object,T> converter, JavaType delegateType, JsonDeserializer<?> delegateDeserializer)` Method used for creating resolved contextual instances.

### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

`_coerceIntegral, _deserializeFromEmpty, _failDoubleToIntCoercion, _hasTextualNull, _isIntNumber, _isNaN, _isNegInf, _isPosInf, _parseBoolean, _parseBooleanFromOther, _parseBooleanPrimitive, _parseByte, _parseDate, _parseDate, _parseDouble, _parseDoublePrimitive, _parseFloat, _parseFloatPrimitive, _parseInteger, _parseIntPrimitive, _parseLong, _parseLongPrimitive, _parseShort, _parseShortPrimitive, _parseString, findConvertingContentDeserializer, findDeserializer, findFormatFeature, findFormatOverrides, getValueClass, getValueType, handleMissingEndArrayForSingle, handleUnknownProperty, isDefaultDeserializer, isDefaultKeyDeserializer, parseDouble`

### Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer

`findBackReference, getEmptyValue, getEmptyValue, getKnownPropertyNames, getNullValue, getNullValue, getObjectIdReader, isCachable, replaceDelegatee, unwrappingDeserializer`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### _converter

    protected final Converter<Object,T> _converter

#### _delegateType

    protected final JavaType _delegateType

Fully resolved delegate type, with generic information if any available.

#### _delegateDeserializer

    protected final JsonDeserializer<Object> _delegateDeserializer

Underlying serializer for type `T`.

### Constructor Detail

#### StdDelegatingDeserializer

    public StdDelegatingDeserializer(Converter<?,T> converter)

#### StdDelegatingDeserializer

    public StdDelegatingDeserializer(Converter<Object,T> converter,
                             JavaType delegateType,
                             JsonDeserializer<?> delegateDeserializer)

#### StdDelegatingDeserializer

    protected StdDelegatingDeserializer(StdDelegatingDeserializer<T> src)

Since:
  2.5

### Method Detail

#### withDelegate

    protected StdDelegatingDeserializer<T> withDelegate(Converter<Object,T> converter,
                                            JavaType delegateType,
                                            JsonDeserializer<?> delegateDeserializer)

Method used for creating resolved contextual instances. Must be overridden when sub-classing.

#### resolve

    public void resolve(DeserializationContext ctxt)
                 throws JsonMappingException

Description copied from interface: `ResolvableDeserializer`
Method called after deserializer instance has been constructed (and registered as necessary by provider objects), but before it has returned it to the caller. Called object can then resolve its dependencies to other types, including self-references (direct or indirect).

Specified by:
  `resolve` in interface `ResolvableDeserializer`
Parameters:
  `ctxt` - Context to use for accessing configuration, resolving secondary deserializers
Throws:
  `JsonMappingException`

#### createContextual

    public JsonDeserializer<?> createContextual(DeserializationContext ctxt,
                                       BeanProperty property)
                                         throws JsonMappingException

Description copied from interface: `ContextualDeserializer`
Method called to see if a different (or differently configured) deserializer is needed to deserialize values of specified property. Note that instance that this method is called on is typically shared one and as a result method should NOT modify this instance but rather construct and return a new instance. This instance should only be returned as-is, in case it is already suitable for use.

Specified by:
  `createContextual` in interface `ContextualDeserializer`
Parameters:
  `ctxt` - Deserialization context to access configuration, additional deserializers that may be needed by this deserializer
  `property` - Method, field or constructor parameter that represents the property (and is used to assign deserialized value). Should be available; but there may be cases where caller can not provide it and null is passed instead (in which case impls usually pass 'this' deserializer as is)
Returns:
  Deserializer to use for deserializing values of specified property; may be this instance or a new instance.
Throws:
  `JsonMappingException`

#### getDelegatee

    public JsonDeserializer<?> getDelegatee()

Description copied from class: `JsonDeserializer`
Accessor that can be used to determine if this deserializer uses another deserializer for actual deserialization, by delegating calls. If so, will return immediate delegate (which itself may delegate to further deserializers); otherwise will return null.

Overrides:
  `getDelegatee` in class `JsonDeserializer<T>`
Returns:
  Deserializer this deserializer delegates calls to, if null; null otherwise.

#### handledType

    public Class<?> handledType()

Description copied from class: `JsonDeserializer`
Method for accessing type of values this deserializer produces. Note that this information is not guaranteed to be exact -- it may be a more generic (super-type) -- but it should not be incorrect (return a non-related type).

Default implementation will return null, which means almost same same as returning `Object.class` would; that is, that nothing is known about handled type.

Overrides:
  `handledType` in class `StdDeserializer<T>`

#### deserialize

    public T deserialize(JsonParser p,
                DeserializationContext ctxt)
                  throws IOException

Description copied from class: `JsonDeserializer`
Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker or a FIELD_NAME.

The two possible input conditions for structured types result from polymorphism via fields. In the ordinary case, Jackson calls this method when it has encountered an OBJECT_START, and the method implementation must advance to the next token to see the first field name. If the application configures polymorphism via a field, then the object looks like the following.

          {
              "@class": "class name",
              ...
          }

Jackson consumes the two tokens (the `@class` field name and its value) in order to learn the class and select the deserializer. Thus, the stream is pointing to the FIELD_NAME for the first field after the @class. Thus, if you want your method to work correctly both with and without polymorphism, you must begin your method with:

           if (jp.getCurrentToken() == JsonToken.START_OBJECT) {
             jp.nextToken();
           }

This results in the stream pointing to the field name, so that the two conditions align.

Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

Note that this method is never called for JSON null literal, and thus deserializers need (and should) not check for it.

Specified by:
  `deserialize` in class `JsonDeserializer<T>`
Parameters:
  `p` - Parsed used for reading JSON content
  `ctxt` - Context that can be used to access information about this deserialization activity.
Returns:
  Deserialized value
Throws:
  `IOException`

#### deserializeWithType

    public Object deserializeWithType(JsonParser p,
                             DeserializationContext ctxt,
                             TypeDeserializer typeDeserializer)
                               throws IOException

Description copied from class: `StdDeserializer`
Base implementation that does not assume specific type inclusion mechanism. Sub-classes are expected to override this method if they are to handle type information.

Overrides:
  `deserializeWithType` in class `StdDeserializer<T>`
  `typeDeserializer` - Deserializer to use for handling type information
Throws:
  `IOException`

#### deserialize

    public T deserialize(JsonParser p,
                DeserializationContext ctxt,
                Object intoValue)
                  throws IOException

Description copied from class: `JsonDeserializer`
Alternate deserialization method (compared to the most commonly used, `JsonDeserializer.deserialize(JsonParser, DeserializationContext)`), which takes in initialized value instance, to be configured and/or populated by deserializer. Method is not necessarily used (or supported) by all types (it will not work for immutable types, for obvious reasons): most commonly it is used for Collections and Maps. It may be used both with "updating readers" (for POJOs) and when Collections and Maps use "getter as setter".

Default implementation just throws `UnsupportedOperationException`, to indicate that types that do not explicitly add support do not necessarily support update-existing-value operation (esp. immutable types)

Overrides:
  `deserialize` in class `JsonDeserializer<T>`
Throws:
  `IOException`

#### _handleIncompatibleUpdateValue

    protected Object _handleIncompatibleUpdateValue(JsonParser p,
                                        DeserializationContext ctxt,
                                        Object intoValue)
                                             throws IOException

Overridable handler method called when `deserialize(JsonParser, DeserializationContext, Object)` has been called with a value that is not compatible with delegate value. Since no conversion are expected for such "updateValue" case, this is normally not an operation that can be permitted, and the default behavior is to throw exception. Sub-classes may choose to try alternative approach if they have more information on exact usage and constraints.

Throws:
  `IOException`
Since:
  2.6

#### convertValue

    protected T convertValue(Object delegateValue)

Method called to convert from "delegate value" (which was deserialized from JSON using standard Jackson deserializer for delegate type) into desired target type.

The default implementation uses configured `Converter` to do conversion.

Parameters:
  `delegateValue` -
Returns:
  Result of conversion